

// Subscripts: ranges and embeddings

#ifndef NULL
  #define  NULL    ((void *)0)
#endif


class Subscript : public Coord {
  friend class Stride ;
  friend class Range ;
  friend class Frame ;
  //friend class Dispatch ;
protected :
  // Primitive range characteristics
  int blockSize ;
  int layerSize ;

  int s_v, s_h ;

  int isRange ;

  int bodge ;  // bodge

  Subscript(int _isRange) : isRange(_isRange) {}
public :
  int distributed() {return dim != NULL ; }
} ;

enum Format {blk, cyc} ;

class Range : public Subscript {
  // Range parameters
  int base ;
  int stride ;
  int extent ;

  // Iterator state.
  int i, i_limit ;

  void blockRange(int*, int*) ;

  friend class Embed ;
  friend class Stride ;
  friend class Fudge ;
  friend class Data ;    // acessess `dim'
public :
  Range(int) ;
  Range(int, Dimension*, Format) ;
  Range(int, Dimension*, Format, int) ;

  Range(int, int, int, Range&) ;

  //Range() : Subscript(1) {}
  Range(const Range& x) :
      Subscript(x), base(x.base), stride(x.stride), extent(x.extent) {}
	  // Copy constructor (NOTE: iterator state is not copied).

  int size() {return extent ;}

  void where() ;
  operator void*() ;
  void operator++() ;
  void erewh() ;

  int operator()(Subscript&) ;
  int operator()() ;

  // Lower level iterations...

  void locBlocksEnum() ;
  int  locBlocksTest() ;
  void locBlocksNext() ;

  void allBlocksEnum() ;
  int  allBlocksTest() ;
  void allBlocksNext() ;

  int blockBase() ;
  int blockCount() ;
  int blockCoord() ;
} ;

class Embed : public Subscript {
  int location ;
public :
  Embed(int, Range&) ;
  //Embed(const Embed&) ;

  int at() ;
  void ta() ;
} ;


inline int max(int x, int y) {return x > y ? x : y ; }
inline int min(int x, int y) {return x < y ? x : y ; }


// ---------------------------------------------------------------
//
// Things to do:
//
//    Understand why `Range' has to be a friend of `Subscript'
//    (the `Range :: operator (Subscript&)' uses protected fields
//    of `Subscript'---should be ok, but doesn't work with some
//    versions of g++).


